﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Windows;
using Egtra;
using Microsoft.Phone.Controls;
using Microsoft.Xna.Framework.Audio;

namespace Cycm
{ 
    [ComImport, Guid("36F21A71-822B-4CD5-9DC9-F1A68FE6AE04"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), CoClass(typeof(DecoderImpl))]
    internal interface IDecoder
    {
        void Init([In] IDebug debug);
        byte[] Decode([MarshalAs(UnmanagedType.LPArray)] byte[] source, int length);
    }

    [ComImport, Guid("D944B6E8-A553-4E4C-9E80-F145D5403927"), ClassInterface(ClassInterfaceType.None)]
    internal class DecoderImpl { }

    public partial class MainPage : PhoneApplicationPage
    {
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();
        }

        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            ComHelper.Register("native2008a.dll", new Guid("209D662D-F3D1-4590-A33F-7924F39323A1"));
            ComHelper.Register("cycmnative.dll", typeof(DecoderImpl));

            var decoder = new IDecoder();
            decoder.Init(new DebugImpl());

            //var rs = Application.GetResourceStream(new Uri("test1.wav", UriKind.Relative));
            //sound = SoundEffect.FromStream(rs.Stream);
            //soundInstance = sound.CreateInstance();
            //SoundEffect.MasterVolume = 1.0f;
            //soundInstance.Play();
            var rs = Application.GetResourceStream(new Uri("cycm.tta", UriKind.Relative));
            byte[] buf = new byte[rs.Stream.Length];
            rs.Stream.Read(buf, 0, buf.Length);
            var result = decoder.Decode(buf, buf.Length);

            sound = SoundEffect.FromStream(new MemoryStream(result));
            soundInstance = sound.CreateInstance();
            SoundEffect.MasterVolume = 1.0f;
            soundInstance.Play();
        }

        SoundEffect sound;
        SoundEffectInstance soundInstance;
    }
}